﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.Routing;

namespace Clib.Route
{
    public class Route
    {
        public static RoutingResult GetRoute(ThinkGeo.MapSuite.Core.PointShape startPoint, ThinkGeo.MapSuite.Core.PointShape endPoint)
        {
            RoutingResult routingResult = new RoutingResult();
            FeatureLayer dkRoadsLayer = Roads.Road.GetDkRoadsLayer(Roads.Road.dkRoads);
            dkRoadsLayer.DrawingExceptionMode = DrawingExceptionMode.ThrowException;
            RoutingSource routingSource = new RtgRoutingSource(Roads.Road.dkRoadsIndex);
            var algorithm = new DijkstraRoutingAlgorithm();
            RoutingEngine routingEngine = new RoutingEngine(routingSource, algorithm, dkRoadsLayer.FeatureSource);
            routingEngine.RoutingResultsType = RoutingResultsType.RouteSegmentsAndFeatures;
            routingResult = routingEngine.GetRoute(startPoint, endPoint);
            return routingResult;
        }

        public static ShapeFileFeatureLayer GetShapeFileLayer(string shapefile)
        {
            ShapeFileFeatureLayer shapefileLayer = new ShapeFileFeatureLayer(shapefile);
            ShapeFileFeatureSource.BuildIndexFile(shapefile, BuildIndexMode.DoNotRebuild);
            shapefileLayer.RequireIndex = true;
            shapefileLayer.ReadWriteMode = ShapeFileReadWriteMode.ReadOnly;
            shapefileLayer.DrawingExceptionMode = DrawingExceptionMode.ThrowException;
            return shapefileLayer;
        }
    }
}
