﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using ThinkGeo.MapSuite.Core;
using Xunit;

namespace XunitTest.Road
{
    public class GetRoadTest
    {
        [Fact]
        public void GetRouteTest()
        {
            var basepath = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location.ToString()) + "\\data";
            Clib.Roads.Road.SetDkRoadsIndex(basepath + @"\sampledata.rtg");
            Clib.Roads.Road.SetDkRoads(basepath + @"\sampledata.shp");
            var xstart = 11.96758d;
            var ystart = 55.33060d;
            var xend = 11.96741d;
            var yend = 55.33168d;
            PointShape _pointshape = new PointShape();
            _pointshape.X = xstart;
            _pointshape.Y = ystart;
            PointShape _pointshapeEnd = new PointShape();
            _pointshapeEnd.X = xend;
            _pointshapeEnd.Y = yend;
            var _route = Clib.Route.Route.GetRoute(_pointshape, _pointshapeEnd);
            var _c = _route.Route;
            
            var _z = Clib.Zone.Zone.Get();
            List<Clib.Zone.Zone.zoneInfoResponse> x = Clib.Zone.Zone.GetZoneInfoInRoute(_route, _z);
            Assert.Equal(_route.Distance, x[0].zoneMeter);
            Assert.True(_route.Distance > 200d);
            Assert.True(_route.Distance < 210d);
        }
    }
}
